SystemOrganization addCategory: #'Caitlin-World'!

Object subclass: #CWPerson
	instanceVariableNames: 'name room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWPerson commentStamp: '<historical>' prior: 0!
I am a person!!!!!!!!(*_*)!

!CWPerson methodsFor: 'as yet unclassified' stamp: 'CMD 11/13/2006 18:13'!
back
	self go: room lastRoom! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'CMD 11/13/2006 18:19'!
forward
	self go: room nextRoom 
! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'CMD 11/13/2006 18:17'!
go: aRoom
	aRoom
		ifNil:[self say: 'you can go no further!!!!!!!!!!!!!!!!!!!!!!!!!!!!silly']
		ifNotNil:[
			room := aRoom.
			self look]
! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'CMD 11/13/2006 17:54'!
look
	self say: room describe! !

!CWPerson methodsFor: 'accessing' stamp: 'CMD 11/13/2006 16:50'!
name
	^name! !

!CWPerson methodsFor: 'accessing' stamp: 'CMD 11/13/2006 16:49'!
name: anObject
	name := anObject! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'CMD 6/18/2007 17:33'!
printString
	^super printString, '(',name,')'! !

!CWPerson methodsFor: 'accessing' stamp: 'CMD 11/13/2006 16:49'!
room
	^room! !

!CWPerson methodsFor: 'accessing' stamp: 'CMD 11/13/2006 16:49'!
room: anObject
	room := anObject! !

!CWPerson methodsFor: 'as yet unclassified' stamp: 'CMD 11/13/2006 17:53'!
say: something
	Transcript show: something ;cr! !

Object subclass: #CWRoom
	instanceVariableNames: 'name description nextRoom lastRoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWRoom commentStamp: '<historical>' prior: 0!
I am a room!!!!!!!!!

!CWRoom methodsFor: 'as yet unclassified' stamp: 'CMD 6/18/2007 16:50'!
describe
	^'* ', name , ' *' , String cr
	,'* ' , description , ' *', String cr
	,(nextRoom 
		ifNotNil:['* the next room is ', nextRoom name, ' *']
		ifNil:['* you can go no further!!!!*'])
	! !

!CWRoom methodsFor: 'accessing' stamp: 'CMD 11/6/2006 16:24'!
description
	^description! !

!CWRoom methodsFor: 'accessing' stamp: 'CMD 11/6/2006 16:26'!
description: aDescription
	description := aDescription! !

!CWRoom methodsFor: 'accessing' stamp: 'CMD 11/6/2006 17:45'!
lastRoom
	^lastRoom! !

!CWRoom methodsFor: 'accessing' stamp: 'CMD 11/6/2006 17:45'!
lastRoom: anObject
	lastRoom := anObject! !

!CWRoom methodsFor: 'as yet unclassified' stamp: 'CMD 11/6/2006 16:19'!
name
	^name! !

!CWRoom methodsFor: 'as yet unclassified' stamp: 'CMD 11/6/2006 16:15'!
name: aName
	name := aName! !

!CWRoom methodsFor: 'accessing' stamp: 'CMD 11/6/2006 17:41'!
nextRoom
	^nextRoom! !

!CWRoom methodsFor: 'accessing' stamp: 'CMD 11/6/2006 17:41'!
nextRoom: anObject
	nextRoom := anObject! !

!CWRoom methodsFor: 'as yet unclassified' stamp: 'CMD 6/18/2007 17:37'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ('(',name,')')! !

Object subclass: #CWWorld
	instanceVariableNames: 'rooms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Caitlin-World'!

!CWWorld commentStamp: 'CMD 6/18/2007 17:22' prior: 0!
ALL THE ROOMS IN THE WORLD ARE HERE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!CWWorld methodsFor: 'as yet unclassified' stamp: 'CMD 6/18/2007 17:32'!
initialize
	| bedroom loungeroom musicroom dadsroom |
	super initialize.
	bedroom := (CWRoom new) name: 'Caitlin''s Bedroom'; description: 'Has a Bunkbed in it'.
	loungeroom := (CWRoom new) name: 'The loungeroom'; description: 'Has ALL the game consoles in it!!!!!!'.
	musicroom := (CWRoom new) name: 'The musicroom'; description: 'Has ALL the music instraments in it'.
	dadsroom := (CWRoom new) name: 'Dad''s Bedroom'; description: 'Has a doublebed in it'.
	bedroom nextRoom: loungeroom; lastRoom: nil.
	loungeroom nextRoom: dadsroom; lastRoom: bedroom.
	dadsroom nextRoom: musicroom; lastRoom: loungeroom.
	musicroom nextRoom: nil; lastRoom: dadsroom.
	
	rooms := OrderedCollection new.
	rooms add: bedroom.
	rooms add: dadsroom.
	rooms add: loungeroom.
	rooms add: musicroom.
! !

!CWWorld methodsFor: 'as yet unclassified' stamp: 'CMD 6/18/2007 17:52'!
newPerson: aName
	| aPerson |
	aPerson := CWPerson new.
	aPerson name: aName.
	aPerson room: rooms first.
	^aPerson! !

!CWWorld methodsFor: 'as yet unclassified' stamp: 'CMD 6/18/2007 17:35'!
rooms
	^rooms! !
